/**********************************************************************/
/* 

   Program: 	DChoice0.prg 
   Subject:  	                
		
   Date: 	14.9.99
   Author(s):   Michael Scheidler  
   Comments:    
		

		10 : 	MNL       					o.k.
			
		21 :	Independent MNP (GHK)				o.k.
		22 : 	Independent MNP (Logit-Kernel)			o.k.
  
		30 :    ABC-MNP 		o.k.
                40/45 :    GAR-MNP 					o.k.

*/


/**********************************************************************/
/***        	1.         Settings                            ***/
/**********************************************************************/



/***************************************************************/
/***                    2. Initialization                  ***/
/***************************************************************/

/* Adresses computation */

 labels  =  getname(data);
 depad   =  indcv(depcen1,labels);
 indad   =  indcv(indcen1,labels);
 ord1ad  =  indcv(ordcen1,labels);
 ord2ad  =  indcv(ordcen2,labels);
 four1ad =  indcv(fourcen1,labels);
 corr1ad =  indcv(corrcen1,labels);
 corr2ad =  indcv(corrcen2,labels);
 
/* Read Data */

 open fh = ^data for read;
 dta     = readr(fh,maxzeil);
 nofl = rows(dta); 

/* Model */

#include DChUti_A.prg;

_kernel=0;
if ( _model ge 40 );
  rndseed rndstart;
  zuf_matr=rndn(rows(dta),_IterKer);
  angebote=angebot(dta);

  marktno   = dta[.,ord1ad];
endif;

/***************************************************************************/

/***************************************************************************/
/********************* 	3. Estimation (Call CML Section) ********************/
/***************************************************************************/

/* 	3.1 Call CML				*/

 __title  = _modname $+ " auf " $+ modstr;
 {x,f0,g,h,retcode} = cml(dta,0,&li,x0);

/* 	3.2 Standard deviations and tvalues 	*/

 s=sqrt(diag(h));
 hesse=h;
 tval = x./s ;


/***************************************************************************/

/***************************************************************************/
/**************		4. Presentation of Results   	************/
/***************************************************************************/

#include DChUti_C.prg;

/***************************************************************************/

/***************************************************************************/
/**************		5. Simulation and Tests          	************/
/***************************************************************************/


#include DChUti_D.prg; /* Simulation */

#include DChUti_E.prg; /* Tests */


/************************** 	End    ************************************/

